unit EditCont;

interface

uses
  SysUtils,
  Forms,
  Dialogs,
  ContSyncML, ComCtrls, StdCtrls, Controls, Classes;

type
  TEditContForm = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Label2: TLabel;
    FNameEd: TEdit;
    Label4: TLabel;
    LNameEd: TEdit;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    MobileEd: TEdit;
    Label1: TLabel;
    PhoneEd: TEdit;
    Label3: TLabel;
    EMailEd: TEdit;
    Label5: TLabel;
    AddressEd: TEdit;
    Label6: TLabel;
    CityEd: TEdit;
    Label7: TLabel;
    StateEd: TEdit;
    Label8: TLabel;
    PostalEd: TEdit;
    Label9: TLabel;
    CountryEd: TEdit;
    Label10: TLabel;
    WebPageEd: TEdit;
    Label15: TLabel;
    TabSheet2: TTabSheet;
    CompanyEd: TEdit;
    Label17: TLabel;
    JobTitleEd: TEdit;
    Label18: TLabel;
    BusFaxEd: TEdit;
    Label19: TLabel;
    BusPhoneEd: TEdit;
    Label20: TLabel;
    BusEMailEd: TEdit;
    Label21: TLabel;
    Label22: TLabel;
    BusWebPageEd: TEdit;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    BusCountryEd: TEdit;
    BusPostalEd: TEdit;
    BusStateEd: TEdit;
    BusCityEd: TEdit;
    BusAddressEd: TEdit;
    TabSheet5: TTabSheet;
    NotesMM: TMemo;
    Label11: TLabel;
    MNameEd: TEdit;
    Label16: TLabel;
    BirthdayTP: TDateTimePicker;
    procedure FormShow(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BirthdayTPClick(Sender: TObject);
  public
    Contact: TSMLContact;
    Contacts: TSMLContacts;
  end;

var
  EditContForm: TEditContForm;

implementation

{$R *.dfm}

procedure TEditContForm.FormShow(Sender: TObject);
begin
  if Contact = nil then
  begin
    Caption := 'Create contact';
    FNameEd.Text := '';
    LNameEd.Text := '';
    MNameEd.Text := '';
    MobileEd.Text := '';
    PhoneEd.Text := '';
    EMailEd.Text := '';
    AddressEd.Text := '';
    CityEd.Text := '';
    StateEd.Text := '';
    PostalEd.Text := '';
    CountryEd.Text := '';
    WebPageEd.Text := '';
    CompanyEd.Text := '';
    JobTitleEd.Text := '';
    BusFaxEd.Text := '';
    BusPhoneEd.Text := '';
    BusEMailEd.Text := '';
    BusWebPageEd.Text := '';
    BusAddressEd.Text := '';
    BusCityEd.Text := '';
    BusStateEd.Text := '';
    BusPostalEd.Text := '';
    BusCountryEd.Text := '';
    NotesMM.Text := '';
    BirthdayTP.DateTime := 0;
    BirthdayTP.Checked := false;
    Contact := Contacts.NewContact;
  end
  else
    with Contact do
    begin
      Caption := 'Edit contact';
      FNameEd.Text := FirstName;
      LNameEd.Text := LastName;
      MNameEd.Text := MiddleName;
      MobileEd.Text := Mobile;
      PhoneEd.Text := Phone;
      EMailEd.Text := EMail;
      AddressEd.Text := Address;
      CityEd.Text := City;
      StateEd.Text := State;
      PostalEd.Text := Postal;
      CountryEd.Text := Country;
      WebPageEd.Text := WebPage;
      CompanyEd.Text := Company;
      JobTitleEd.Text := JobTitle;
      BusFaxEd.Text := BusinessFax;
      BusPhoneEd.Text := BusinessPhone;
      BusEMailEd.Text := BusinessEMail;
      BusWebPageEd.Text := BusinessWebPage;
      BusAddressEd.Text := BusinessAddress;
      BusCityEd.Text := BusinessCity;
      BusStateEd.Text := BusinessState;
      BusPostalEd.Text := BusinessPostal;
      BusCountryEd.Text := BusinessCountry;
      NotesMM.Text := Notes;
      BirthdayTP.DateTime := Birthday;
      BirthdayTP.Checked := BirthdayTP.DateTime <> 0;
    end;
  PageControl1.TabIndex := 0;
  FNameEd.SetFocus;
end;

procedure TEditContForm.OKBtnClick(Sender: TObject);
begin
  if Trim(FNameEd.Text + LNameEd.Text) = '' then
  begin
    Showmessage('Please enter at least one name');
    ModalResult := mrNone;
    Exit;
  end;
  with Contact do
  begin
    FirstName := FNameEd.Text;
    LastName := LNameEd.Text;
    MiddleName := MNameEd.Text;
    Mobile := MobileEd.Text;
    Phone := PhoneEd.Text;
    EMail := EMailEd.Text;
    Address := AddressEd.Text;
    City := CityEd.Text;
    State := StateEd.Text;
    Postal := PostalEd.Text;
    Country := CountryEd.Text;
    WebPage := WebPageEd.Text;
    Company := CompanyEd.Text;
    JobTitle := JobTitleEd.Text;
    BusinessFax := BusFaxEd.Text;
    BusinessPhone := BusPhoneEd.Text;
    BusinessEMail := BusEMailEd.Text;
    BusinessWebPage := BusWebPageEd.Text;
    BusinessAddress := BusAddressEd.Text;
    BusinessCity := BusCityEd.Text;
    BusinessState := BusStateEd.Text;
    BusinessPostal := BusPostalEd.Text;
    BusinessCountry := BusCountryEd.Text;
    Notes := NotesMM.Text;
    Birthday := BirthdayTP.DateTime;
  end;
end;

procedure TEditContForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if (Caption = 'Create contact') and (ModalResult <> mrOK) then
    Contact.Delete;
end;

procedure TEditContForm.BirthdayTPClick(Sender: TObject);
begin
  with BirthdayTP do
    if not Checked then
    begin
      DateTime := 0;
      Checked := false;
    end;
end;

end.

